.386
.model  flat, stdcall
option  casemap:none

include		\GeneSys\include\windows.inc
include		\GeneSys\include\kernel32.inc
include		\GeneSys\include\user32.inc

includelib	\GeneSys\lib\kernel32.lib
includelib	\GeneSys\lib\user32.lib

CustomMsgBox PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
msg1		db 'This is a customized message box',0
capt		db 'Hello!',0
btext		db 'Click here',0

.data?
hMboxHook	dd ?
pButtonText	dd ?

.code

start:

	invoke	CustomMsgBox,0,ADDR msg1,ADDR capt,ADDR btext
	invoke	ExitProcess,0

mboxCBTProc PROC nCode:DWORD,wParam:DWORD,lParam:DWORD

	cmp		nCode,0
	jb		@f
	cmp		nCode,HCBT_ACTIVATE
	jne		@f
	invoke	GetDlgItem,wParam,IDOK
	invoke	SetWindowText,eax,pButtonText
	xor		eax,eax
	ret	
@@:
	invoke	CallNextHookEx,hMboxHook,nCode,wParam,lParam
	ret

mboxCBTProc ENDP

CustomMsgBox PROC hWnd:DWORD,message:DWORD,caption:DWORD,buttontext:DWORD

	mov		eax,buttontext
	mov		pButtonText,eax
	invoke	GetCurrentThreadId
	invoke	SetWindowsHookEx,WH_CBT,ADDR mboxCBTProc,NULL,eax
	mov		hMboxHook,eax
	invoke	MessageBox,0,message,caption,MB_OK
	invoke	UnhookWindowsHookEx,hMboxHook
	ret

CustomMsgBox ENDP

END start